unit wxoExec;

interface

uses
     //Ա
     wxoUnit,

     //ϵͳ
     ExtCtrls,Forms, Variants, Classes, Graphics, Controls,
     StdCtrls,
     SysUtils,Dialogs,Messages,Windows;
type
     TWXOCustom = class
     end;

     TWXOMonitor = class(TWXOCustom)
          Timer : TTimer;
     public
          constructor Create;
          procedure OnTimerTick(Sender: TObject);
     end;



var
     _WXO_MainFormHandle      : THandle;     //ڱ
     _WXO_ApplicationHandle   : THandle;     //ڱӦþ

     //
     oMonitor  : TWXOMonitor;                //WXOض

     
procedure wxoPrepare(frmHd,appHd:THandle);
procedure wxoSendMessage(DestHandle,LocalHandle:THandle;Head:string;Value:LongInt;Text:string);
procedure wxoClose;
function  wxoShowModal(AForm,AMainForm : TForm):Integer;

implementation

//uses Unit1;

procedure wxoClose;
begin
     wxoSendMessage(giApp,_WXO_MainFormHandle,'RNJS',_WXO_MainFormHandle,'window.open('''',''_self'','''');'#13#10'window.close();');
end;

function GetDllName:string;
var
     Buf: array[0..MAX_PATH] of char;
begin
     GetSystemDirectory(Buf, MAX_PATH);
     Result := Trim(Buf);
     //
     Result    := Result[1] +':\WebXone\wxoExec.dll';
end;

procedure wxoSendMessage(DestHandle,LocalHandle:THandle;Head:string;Value:LongInt;Text:string);
type
     TwxoSM = procedure(DestHandle,LocalHandle:THandle;Head:PChar;Value:LongInt;Text:PChar);cdecl;
var
     Hinst     : Thandle;
     wxoSM     : TwxoSM;
begin
     Hinst     := loadlibrary(PChar(GetDllName));//LoadһDll,ļҡ
     if Hinst>0 then begin
          wxoSM     := GetProcAddress(Hinst,'wxoSendMessage');//ңСдС֪Զıʾˡ
          wxoSM(DestHandle,LocalHandle,PChar(Head),Value,PChar(Text));//ҵָ͵á
     end;
     Freelibrary(Hinst);
end;




procedure wxoPrepare(frmHd,appHd:THandle);
type
     TPrepare = procedure (Handle,AppHandle,ParHandle:THandle);cdecl;
var
     iHandle   : THandle;
     Prepare   : TPrepare;
begin
     try
          //<һʱ
          oMonitor  := TWXOMonitor.Create;
          //>


          //giAppʼֵ
          giApp     := 0;

          if ParamCount>2 then begin
               //ִвеõֵ
               giApp     := StrToIntDef(ParamStr(1),0);
               giCtrl    := StrToIntDef(ParamStr(2),0);
               gsUrl     := ParamStr(3);
               //ShowMessage(IntToStr(ParamCount)+' '+gsUrl);

               //ֵԱ
               _WXO_MAINFORMHANDLE      := frmHd;
               _WXO_ApplicationHandle   := appHd;
               //ShowMessage(IntToStr(_WXO_MAINFORMHANDLE));

               //ֵп
               if (giApp>0)and(giCtrl>0) then begin
                    //
                    iHandle     := LoadLibrary(PChar(GetDllName));//LoadһDll,ļҡ
                    if iHandle>0 then begin
                         @Prepare   := GetProcAddress(iHandle,'wxoPrepare');  //ңСд
                         if Assigned(Prepare) then begin
                              Prepare(frmHd,AppHd,giApp);
                         end;
                    end;
                    FreeLibrary(iHandle);

                    //ϢԿ
                    wxoSendMessage(giApp,frmHd,'EMEX',AppHd,'0');
               end;
          end else begin
                Application.Terminate;
          end;
     except
          MessageDlg('Cannot execute the program!',mtError,[mbOK],0);
     end;
end;

{ TWXOMonitor }

constructor TWXOMonitor.Create;
begin
    inherited;
    Timer := TTimer.Create(nil);
    Timer.OnTimer   := OnTimerTick;
    Timer.Interval  := 5000;
    Timer.Tag       := 0;
end;
  
procedure TWXOMonitor.OnTimerTick(Sender: TObject);
begin
     if not IsWindow(giApp) then begin
          Application.Terminate;
     end;
end;

function wxoShowModal(AForm,AMainForm : TForm):Integer;
var
     I         : Integer;
     bEnableds : array of Boolean;
     bMenus    : array of Boolean;
     oMClick   : TNotifyEvent;
     oMDown    : TMouseEvent;
     oMMove    : TMouseMoveEvent;
     oMUp      : TMouseEvent;
     oMWheel   : TMouseWheelEvent;
     oMWDown   : TMouseWheelUpDownEvent;
     oMWUp     : TMouseWheelUpDownEvent;
begin
     //
     if AForm=nil then begin
          Exit;
     end;

     try
          //ȡԭ״̬Enabled
          SetLength(bEnableds,AMainForm.ControlCount);
          for I:=0 to High(bEnableds) do begin
               bEnableds[I]   := AMainForm.Controls[I].Enabled;
               AMainForm.Controls[I].Enabled := False;
          end;

          //ԭ˵״̬
          if AMainForm.Menu<>nil then begin
               SetLength(bMenus,AMainForm.Menu.Items.Count);
               for I:=0 to AMainForm.Menu.Items.Count-1 do begin
                    bMenus[I] := AMainForm.Menu.Items[I].Enabled;
                    AMainForm.Menu.Items[I].Enabled := False;
               end;
          end;

          //AMainForm.onmouse

          //¼
          oMClick   := AMainForm.OnClick;
          oMDown    := AMainForm.OnMouseDown;
          oMMove    := AMainForm.OnMouseMove;
          oMUp      := AMainForm.OnMouseUp;
          oMWheel   := AMainForm.OnMouseWheel;
          oMWDown   := AMainForm.OnMouseWheelDown;
          oMWUp     := AMainForm.OnMouseWheelUp;

          //¼
          AMainForm.OnClick             := nil;
          AMainForm.OnMouseDown         := nil;
          AMainForm.OnMouseMove         := nil;
          AMainForm.OnMouseUp           := nil;
          AMainForm.OnMouseWheel        := nil;
          AMainForm.OnMouseWheelDown    := nil;
          AMainForm.OnMouseWheelUp      := nil;

          //ʾ
          AForm.Show;
          AForm.Update;
          Windows.SetParent(AForm.Handle,AMainForm.Handle);
          while AForm.Visible do begin
               Application.HandleMessage;
          end;
          Windows.SetParent(AForm.Handle,0);

     finally
          //ָ״̬
          for I:=0 to High(bEnableds) do begin
               AMainForm.Controls[I].Enabled      := bEnableds[I];
          end;
          for I:=0 to High(bMenus) do begin
               AMainForm.Menu.Items[I].Enabled    := bMenus[I];
          end;
          //
          AMainForm.OnClick             := oMClick;
          AMainForm.OnMouseDown         := oMDown;
          AMainForm.OnMouseMove         := oMMove;
          AMainForm.OnMouseUp           := oMUp;
          AMainForm.OnMouseWheel        := oMWheel;
          AMainForm.OnMouseWheelDown    := oMWDown;
          AMainForm.OnMouseWheelUp      := oMWUp;
     end;
end;


end.
